//CopierAttributsBlocs_303f.js
// 17.09.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Copier les attributs d'un bloc  un autre

// Reprendre les dimensions et/ou la position du bloc modle
// quand une la variable est dfinie comme 'false', les valeurs 
// correspondantes ne sont pas reprises.
// Pour dsactiver une ligne: insrer deux barres de fraction au dbut,
// pour activer une ligne: supprimer les deux barres de fraction

// Remarque: la valeur de 'copyPos' est ignore lorsque les deux 
// blocs slectionns se trouvent dans le mme document
var copySize = true;    // reprendre les dimensions du bloc
//var copySize = false; // ne pas modifier les dimensions du bloc
var copyPos  = true;    // reprendre la position du bloc modle
//var copyPos  = false; // ne pas dplacer le bloc cible

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// appeler la fonction qui liste les documents ouverts
docRef = getDocRef();
nRefs  = docRef.length;
if (nRefs == 1) {
	docOne = docRef[0];
	docTwo = docRef[0];
	sameDoc = true;
	a = 0;
	b = 1;
}
else {
	docOne = docRef[0];
	docTwo = docRef[1];
	if (docOne == docTwo) {
		alert ("Les noms des deux documents ne doivent pas tre identiques.", "Stop");
		exit();
	}
	sameDoc = false;
	a = 0;
	b = 0;
}

// vrifier si les deux variables sont initialises
try {
	testVal = copySize;
}
catch (e) {
	alert ("Activer la variable \"copySize\".", "Stop");
	exit();
}
if (!sameDoc) {
	try {
		testVal = copyPos;
	}
	catch (e) {
	alert ("Activer la variable \"copyPos\".", "Stop");
		exit();
	}
}
else {
	copyPos = false;
}

// mmoriser l'origine des rgles et les modifier  "Planche"
ro0 = app.documents.itemByName(docOne).viewPreferences.rulerOrigin;
if (!sameDoc) {
	ro1 = app.documents.itemByName(docTwo).viewPreferences.rulerOrigin;
}
if (ro0 != 1380143983) {
	app.documents.itemByName(docOne).viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
}
if (!sameDoc) {
	if (ro1 != 1380143983) {
		app.documents.itemByName(docTwo).viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
	}
}

// appeler la fonction qui vrifie la slection
checkSel();

// tenter de deviner le bloc modle (quand il n'y a qu'un document)
if (sameDoc) {
	frameA = app.documents.itemByName(docOne).selection[a];
	frameB = app.documents.itemByName(docOne).selection[b];
	var aFillColor = frameA.fillColor.name;
	var bFillColor = frameB.fillColor.name;
	if (aFillColor == "None") {
		if (bFillColor != "None") {
			app.select(frameA, SelectionOptions.REMOVE_FROM);
			masterSelected = askUser();
			app.select(frameA, SelectionOptions.ADD_TO);
		}
		else {
			app.select(frameB, SelectionOptions.REMOVE_FROM);
			masterSelected = askUser();
			app.select(frameB, SelectionOptions.ADD_TO);
		}
	}
	else {
		app.select(frameB, SelectionOptions.REMOVE_FROM);
		masterSelected = askUser();
		app.select(frameB, SelectionOptions.ADD_TO);
	}
	if (masterSelected) {
		a = 1;
		b = 0;
	}
}

// aller chercher les dimensions (si demand)
if (copySize || copyPos) {
	getBounds();
}

// appeler la fonction correspondante au rglage
if (copySize && copyPos) {
	setBounds();
}
else if (copySize && !copyPos) {
	setSize();
}
else if (!copySize && copyPos) {
	setPos();
}

// appeler la fonction qui applique les attributs
setProps();

// appeler la fonction pour restaurer l'origine des rgles
resetAsBefore();


///////////////////////////////////////////////////////////////////////////////
// les fonctions
///////////////////////////////////////////////////////////////////////////////

// dresser la liste des documents ouverts
function getDocRef() {
	docRef = new Array ();
	nDocs = app.documents.length;
	if (nDocs !=0) {
		for (var i=0; i<app.documents.length; i++) {
			docRef.push(app.documents[i].name);
		}
	}
	else {
		alert ("Il n'y a pas de document ouvert.", "Attention");
		exit();
	}
	return docRef;
}

// die Auswahl prfen
function checkSel() {
	try {
		var testType1 = app.documents.itemByName(docOne).selection[a].constructor.name;
		if (testType1 != "Rectangle" && testType1 != "TextFrame") {
			if (testType1 == "Group") {
				resetAsBefore();
				alert ("Document \"" + docOne + "\":" + "\n\nne pas slectionner un groupe.", "Stop");
				exit();
			}
			else {
				resetAsBefore();
				alert ("Document \"" + docOne + "\":" + "\n\nne slectionner que des rectangles.", "Stop");
				exit();
			}
		}
	}
	catch (e) {
		resetAsBefore();
		alert ("Document \"" + docOne + "\":" + "\n\nil n'y a pas de slection.", "Attention");
		exit();
	}
	try {
		var testType2 = app.documents.itemByName(docTwo).selection[b].constructor.name;
		if (testType2 != "Rectangle" && testType2 != "TextFrame") {
			if (testType2 == "Group") {
				resetAsBefore();
				alert ("Document \"" + docTwo + "\":" + "\n\nne pas slectionner un groupe.", "Stop");
				exit();
			}
			else {
				resetAsBefore();
				alert ("Document \"" + docTwo + "\":" + "\n\nne slectionner que des rectangles.", "Stop");
				exit();
			}
		}
	}
	catch (e) {
		resetAsBefore();
		if (sameDoc) {
			alert ("Document \"" + docTwo + "\":" + "\n\n" + "il faut slectionner le bloc cible.", "Attention");
		}
		else {
			alert ("Document \"" + docTwo + "\":" + "\n\n" + "il n'y a pas de slection.", "Attention");
		}
		exit();
	}
}

// mmoriser les dimension
function getBounds() {
	try {
		boxRotation1 = app.documents.itemByName(docOne).selection[a].rotationAngle;
		if (boxRotation1 != 0) {
			app.documents.itemByName(docOne).selection[a].rotationAngle = 0;
		}
		boxBounds1 = app.documents.itemByName(docOne).selection[a].geometricBounds;
		if (boxRotation1 != 0) {
			app.documents.itemByName(docOne).selection[a].rotationAngle = boxRotation1;
		}
	}
	catch (e) {
	}
	try {
		boxBounds2 = app.documents.itemByName(docTwo).selection[b].geometricBounds;
		boxRotation2 = app.documents.itemByName(docTwo).selection[b].rotationAngle;
	}
	catch (e) {
	}
}

// le dialogue servant  rpondre  la question si le bloc modle est rest slectionn
function askUser() {
	// effacer des dialogues rests ouverts
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// prparer le dialogue
	var aDialog = app.dialogs.add({name:"La slection du bloc modle"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Qu'est-ce qui est juste?"});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var folButtons = radiobuttonGroups.add();
				with (folButtons) {
					radiobuttonControls.add({staticLabel:"le bloc modle est slectionn", checkedState:true});
					radiobuttonControls.add({staticLabel:"le bloc modle n'est plus slectionn", checkedState:false});
				}
			}
		}
	}
	// afficher le dialogue et mmoriser le rsultat
	var dResult = aDialog.show();
	if (dResult == true) {
		var folBtn = folButtons.selectedButton;
		if (folBtn == 0) {
			dlogResult = true;
		}
		else if (folBtn == 1) {
			dlogResult = false;
		}
		aDialog.destroy();
		return dlogResult;
	}
	else {
		resetAsBefore();
		aDialog.destroy();
		exit();
	}
}

// appliquer les dimensions et la position
function setBounds() {
	try {
		if (boxRotation1 == 0 && boxRotation2 != 0 || boxRotation1 != 0 && boxRotation2 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = 0;
		}
		app.documents.itemByName(docTwo).selection[b].geometricBounds = boxBounds1;
	}
	catch (e){
	}
	try {
		if (boxRotation1 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = boxRotation1;
		}
	}
	catch (e){
	}
}

// n'appliquer que les dimensions
function setSize() {
	try {
		if (boxRotation2 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = 0;
		}
		var gB = app.documents.itemByName(docTwo).selection[b].geometricBounds;
		var y1 = gB[0];
		var x1 = gB[1];
		var fH = boxBounds1[2]-boxBounds1[0];
		var fW = boxBounds1[3]-boxBounds1[1];
		app.documents.itemByName(docTwo).selection[b].geometricBounds = [y1, x1, y1+fH, x1+fW];
	}
	catch (e){
	}
	try {
		if (boxRotation1 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = boxRotation1;
		}
	}
	catch (e){
	}
}

// seulement dplacer  la position (sans modifier les dimensions)
function setPos() {
	try {
		if (boxRotation2 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = 0;
		}
		var gB = app.documents.itemByName(docTwo).selection[b].geometricBounds;
		var y1 = boxBounds1[0];
		var x1 = boxBounds1[1];
		app.documents.itemByName(docTwo).selection[b].move([x1, y1], undefined);
	}
	catch (e){
	}
	try {
		if (boxRotation1 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = boxRotation1;
		}
	}
	catch (e){
	}
}

// appliquer les attributs
function setProps() {
	curProps = app.documents.itemByName(docOne).selection[a].properties;
	targetFrame = app.documents.itemByName(docTwo).selection[b];
	var boxWrap = curProps.textWrapPreferences.textWrapOffset;
	var fic = curProps.fillColor.name;
	var fit = curProps.fillTint;
	var opa = curProps.opacity;
	var frw = curProps.strokeWeight;
	var fry = curProps.strokeType;
	var frc = curProps.strokeColor.name;
	var frt = curProps.strokeTint;
	var fra = curProps.strokeAlignment;
	var cef = curProps.cornerEffect;
	var crd = curProps.cornerRadius;
	if (fic != "None") {
		testColor(fic);
	}
	if (frc != "None") {
		testColor(frc);
	}
	targetFrame.properties = {strokeAlignment:fra, fillColor:fic, fillTint:fit, opacity:opa, 
		strokeWeight:frw, strokeType:fry, strokeColor:frc, strokeTint:frt, cornerEffect:cef, cornerRadius:crd};
	if (boxWrap != 1852796517) {
		var wrapType = curProps.textWrapPreferences.textWrapType;
		targetFrame.textWrapPreferences.textWrapType = wrapType;
		targetFrame.textWrapPreferences.textWrapOffset = boxWrap;
	}
	var shm = curProps.transparencySettings.dropShadowSettings;
	if (shm.mode != 1852796517) {
		var shc = shm.effectColor.name;
		testColor(shc);
		var san = shm.angle;
		var sbm = shm.blendMode;
		var sdi = shm.distance;
		var she = shm.honorOtherEffects;
		var sko = shm.knockedOut;
		var shn = shm.noise;
		var sho = shm.opacity;
		var sbr = shm.size;
		var sgl = shm.useGlobalLight;
		var shs = shm.spread;
		var sxo = shm.xOffset;
		var syo = shm.yOffset;
		targetFrame.transparencySettings.dropShadowSettings.properties = 
		{mode:2020623440, angle:san, blendMode:sbm, distance:sdi, effectColor:shc, honorOtherEffects:she, 
		knockedOut:sko, noise:shn, opacity:sho, size:sbr, spread:shs, useGlobalLight:sgl, xOffset:sxo, yOffset:syo};
	}
	else {
		targetFrame.transparencySettings.dropShadowSettings.mode = 1852796517;
	}
	if (targetFrame.constructor.name == "TextFrame") {
		try {
			var txtFrPrefs = curProps.textFramePreferences.properties;
			targetFrame.textFramePreferences.properties = txtFrPrefs;
		}
		catch (e) {
		}
	}
}

// la fonction qui vrifie l'existence des couleurs
// (une couleur manquante est cr)
function testColor(curName) {
	if (!sameDoc) {
		try {
			colorProps2 = app.documents.itemByName(docTwo).colors.item(curName).properties;
		}
		catch (e) {
			try {
				colorProps1 = app.documents.itemByName(docOne).colors.item(curName).properties;
				var newColor = app.documents.itemByName(docTwo).colors.add({name:curName});
				newColor.properties = colorProps1;
				newColor.name = curName;
			}
			catch (e) {
			}
		}
	}
}

// restaurer l'origine des rgles (si ncessaire)
function resetAsBefore() {
	if (ro0 != 1380143983) {
		ro0 = app.documents.itemByName(docOne).viewPreferences.rulerOrigin = ro0;
	}
	if (!sameDoc) {
		if (ro1 != 1380143983) {
			ro1 = app.documents.itemByName(docTwo).viewPreferences.rulerOrigin = ro1;
		}
	}
}